
// Updated: 18th May 2005

// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

#define	_WIN32_DCOM
//#define	_COMSTL_NO_UUIDOF

#include <comstl.h>
#include <comstl/initialisers.hpp>
#include <comstl/thread_marshal.hpp>

using ::comstl::com_initialiser;
using ::comstl::MarshalInterThreadInterfaceInStream;
using ::comstl::GetInterfaceAndReleaseStream;

#include "..\server\server.h"
#include "..\server\server_i.c"

COMSTL_IID_TRAITS_DEFINE(IMarshalTest)

#include <stdio.h>

////////////////////////////////////////////////////////////////////////////////
// Compiler warnings

#ifdef __STLSOFT_COMPILER_IS_INTEL
# pragma warning(disable : 698)
#endif /* __STLSOFT_COMPILER_IS_INTEL */

////////////////////////////////////////////////////////////////////////////////

#if 0
#include <stlsoft.h>
#include <stlsoft_true_typedef.h>

#include <string>

using ::std::string;

////////////////////////////////////////////////////////////////////////////////

stlsoft_gen_opaque(h_channel_tt)
typedef	stlsoft_ns_qual(true_typedef)<long, h_channel_tt>			channel_tt;

stlsoft_gen_opaque(h_thread_tt)
typedef	stlsoft_ns_qual(true_typedef)<long, h_thread_tt>			thread_tt;

stlsoft_gen_opaque(h_string1_tt)
typedef	stlsoft_ns_qual(true_typedef)< ::std::string, h_string1_tt>	string1_tt;

stlsoft_gen_opaque(h_string2_tt)
typedef	stlsoft_ns_qual(true_typedef)< ::std::string, h_string2_tt>	string2_tt;

void func1(channel_tt v)
{
	typedef	channel_tt	type;

	long	l		=	v.base_type_value();

	size_t	si_tt	=	sizeof(type);
	size_t	si_t	=	sizeof(type::value_type);

	fprintf(stdout, "channel_tt: %d, %d\n", si_tt, si_t);
}

void func1(thread_tt v)
{
	typedef	thread_tt	type;

	long	l	=	v.base_type_value();
	size_t	si	=	sizeof(v);


	size_t	si_tt	=	sizeof(type);
	size_t	si_t	=	sizeof(type::value_type);

	fprintf(stdout, "thread_tt: %d, %d\n", si_tt, si_t);
}

void func1(string1_tt v)
{
	typedef	string1_tt	type;

	string	s	=	v.base_type_value();
	size_t	si	=	sizeof(v);


	size_t	si_tt	=	sizeof(type);
	size_t	si_t	=	sizeof(type::value_type);

	fprintf(stdout, "string1_tt: %d, %d\n", si_tt, si_t);
}

void func1(string2_tt v)
{
	typedef	string2_tt	type;

	string	s	=	v.base_type_value();
	size_t	si	=	sizeof(v);


	size_t	si_tt	=	sizeof(type);
	size_t	si_t	=	sizeof(type::value_type);

	fprintf(stdout, "string2_tt: %d, %d\n", si_tt, si_t);
}

void func()
{
	channel_tt	ch(10);
	thread_tt	th(20);

	channel_tt	ch2(ch);
	thread_tt	th2(th);

	string1_tt	s1h1("Hello, Natty!");
	string2_tt	s2h1(s1h1.base_type_value());

#if 0
	channel_tt	ch3(th);
	thread_tt	th3(ch);
#endif /* 0 */

#if 0
	string1_tt	s1h2(s2h1);
	string2_tt	s2h2(s1h1);
#endif /* 0 */

	func1(ch);
	func1(th);

	void (*_func1)(thread_tt )	=	func1;

	_func1(thread_tt(10));

	func1(s1h1);
	func1(s2h1);
}
#endif /* 0 */

////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI ThreadProc(LPVOID lpThreadParameter);

int main(int /* argc */, char ** /*argv*/)
{
//	func();

    com_initialiser coinit(COINIT_APARTMENTTHREADED);   // Initialise COM
    HRESULT         hr;

    if(!coinit)
    {
        hr = E_UNEXPECTED;
    }
    else
    {
        IMarshalTest	*pitf;

        // Attempt to create the object
        hr = ::CoCreateInstance(CLSID_MarshalTest,
                                NULL,
                                CLSCTX_INPROC_SERVER,
                                IID_IMarshalTest,
                                (void**)&pitf);

        if(SUCCEEDED(hr))
        {
			SOMESTRUCT			ss;
			IOther				*pother	=	NULL;

			pitf->NonNullMethod(ss, *pother);

			LPSTREAM			pstm;
#if 0
			HRESULT				hr		=	::CoMarshalInterThreadInterfaceInStream(IID_IMarshalTest, pitf, &pstm);
#else
			HRESULT				hr		=	MarshalInterThreadInterfaceInStream(pitf, &pstm);
#endif /* 0 */
			DWORD				threadid;
			HANDLE				hThread	=	::CreateThread(NULL, 0, ThreadProc, pstm, 0, &threadid);

			if(hThread == NULL)
			{
				pstm->Release();
			}

//			::WaitForSingleObject(hThread, INFINITE);

			for(;;)
			{
				DWORD	res	=	::MsgWaitForMultipleObjects(1, &hThread, false, INFINITE, QS_ALLEVENTS);

				if(res == WAIT_OBJECT_0)
				{
					break;
				}
				else if(res == WAIT_OBJECT_0 + 1)
				{
					MSG	msg;

					while(::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
					{
						::DispatchMessage(&msg);
					}
				}
				else
				{
					break;
				}
			}

            // Release the reference
            pitf->Release();
        }
    }

    return 0;
}

DWORD WINAPI ThreadProc(LPVOID lpThreadParameter)
{
	//
    com_initialiser		coinit(COINIT_APARTMENTTHREADED);   // Initialise COM

	SOMESTRUCT			ss;
	IOther				*pother	=	NULL;
	LPSTREAM			pstm	=	(LPSTREAM)lpThreadParameter;
	IMarshalTest		*pitf;
	HRESULT				hr		=	GetInterfaceAndReleaseStream(pstm, &pitf);

	pitf->NonNullMethod(ss, *pother);

	pitf->Release();

	return 0;
}
