/* /////////////////////////////////////////////////////////////////////////////
 * File:		listview_sequence_test.cpp
 *
 * Purpose:
 *
 * Created:		11th December 2002
 * Updated:		6th June 2005
 *
 * Copyright:	Synesis Software Pty Ltd, (c) 2002. All rights reserved.
 *
 * Home:		www.winstl.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

#include <winstl.h>

#include <winstl_listview_sequence.h>

#include <stlsoft_string_access.h>

stlsoft_ns_using (c_str_ptr)
stlsoft_ns_using (c_str_ptr_null)

#include <algorithm>

winstl_ns_using_std(for_each)

#include <string>

winstl_ns_using_std(string)

#include <stdio.h>

////////////////////////////////////////////////////////////////////////////////

struct dump_string
{
#ifdef __STLSOFT_CF_MEMBER_TEMPLATE_FUNCTION_SUPPORT
	template <ss_typename_param_k T>
	void operator ()(T const &s)
#else
	void operator ()(string const &s)
#endif /* __STLSOFT_CF_MEMBER_TEMPLATE_FUNCTION_SUPPORT */
	{
		if(c_str_ptr_null(s))
		{
			printf("  %s\n", static_cast<const char*>(c_str_ptr(s)));
		}
	}
};

int main(int /* argc */, char ** /*argv*/)
{
	typedef winstl_ns_qual(listview_sequence)	listview_sequence;

	::InitCommonControls();

	HWND	hwndListView	=	::CreateWindowExA(0, "SysListView32", "", LBS_SORT, 0, 0, 0, 0, 0, 0, 0, 0);
	int		iItem;
	LV_ITEM	item;

	item.mask		=	LVIF_TEXT;
	item.iSubItem	=	0;

	item.iItem		=	0;
	item.pszText	=	"String 3";
	iItem	=	ListView_InsertItem(hwndListView, &item);

	item.iItem		=	1;
	item.pszText	=	"String 2";
	iItem	=	ListView_InsertItem(hwndListView, &item);

	item.iItem		=	2;
	item.pszText	=	"String 45";
	iItem	=	ListView_InsertItem(hwndListView, &item);

	item.iItem		=	3;
	item.pszText	=	"String 1";
	iItem	=	ListView_InsertItem(hwndListView, &item);

	listview_sequence					lbs(hwndListView);

	printf("Forward:\n");
	for_each(lbs.begin(), lbs.end(), dump_string());

#ifdef __STLSOFT_CF_BIDIRECTIONAL_ITERATOR_SUPPORT
	printf("Backward:\n");
	for_each(lbs.rbegin(), lbs.rend(), dump_string());
#endif /* __STLSOFT_CF_BIDIRECTIONAL_ITERATOR_SUPPORT */

	printf("Indexed:\n");
	for(size_t i = 0; i < lbs.size(); ++i)
	{
		dump_string()(lbs[i]);
	}

    return 0;
}

////////////////////////////////////////////////////////////////////////////////
