/* /////////////////////////////////////////////////////////////////////////////
 * File:        unittest.cpp
 *
 * Purpose:		Unit test file for PlatformSTL
 *
 * Created:		16th May 2005
 * Updated:     16th May 2005
 *
 * Author:      Matthew Wilson
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2005. All rights reserved.
 *
 * Home:        www.stlsoft.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


// Must define this
#ifndef STLSOFT_UNITTEST
# error This file cannot be used if STLSOFT_UNITTEST is not defined.
#endif /* !STLSOFT_UNITTEST */

#if defined(__MWERKS__)
# if defined(_STLSOFT_COMPILE_VERBOSE)
#  undef _STLSOFT_COMPILE_VERBOSE
# endif /* _STLSOFT_COMPILE_VERBOSE */
#endif /* __MWERKS__ */

#ifdef __BORLANDC__
# pragma warn -8008
# pragma warn -8066
# include <windows.h>
#endif /* __BORLANDC__ */

#include <stdio.h>
#include <platformstl/platformstl.h>
#include <unittest/simple_unittester.h>

#if defined(__STLSOFT_COMPILER_IS_INTEL)
# if !defined(__MWERKS__)
#  define __MWERKS__	(0)
# endif /* !__MWERKS__ */
# if !defined(__DMC__)
#  define __DMC__	(0)
# endif /* !__DMC__ */
#endif /* !__STLSOFT_COMPILER_IS_MSVC */

////////////////////////////////////////////////////////////////////////////////
// main

//extern "C" void __stdcall Sleep(unsigned long);

int main(int argc, char **argv)
{
//	Sleep(100000);

	int		i;
	bool	bVerbose	=	false;

	for(i = 1; i < argc; ++i)
	{
		if(	0 == strcmp(argv[i], "-v") ||
			0 == strcmp(argv[i], "-verbose"))
		{
			bVerbose = true;
		}
	}

	puts("Running PlatformSTL unittests");

	return !::stlsoft::unittest::simple_unittest_host::get_host()->test(bVerbose);
}

////////////////////////////////////////////////////////////////////////////////
